#define NULE 0
#define MULE 8888

typedef struct NOiD_memory
{
	int id;
	int size;
	struct NOiD_memory * last;
	struct NOiD_memory * next;
} NOiD_memory;

typedef struct NOiD_yromem
{
	NOiD_memory * space;
	int id;
} NOiD_yromem;

NOiD_memory * NOiD_seg (void * , int );
void * NOiD_alloc (NOiD_memory * , int );
void NOiD_free (NOiD_memory * , void * );

//==========================

typedef struct NOiD_node
{
	void * pack;
	struct NOiD_node * last;
	struct NOiD_node * next;
} NOiD_node;

NOiD_node * NOiD_create (NOiD_node * noid_src, void * noid_pack, void * noid_ptr);
void NOiD_destroy (NOiD_node * noid_src, NOiD_node * noid_nud);
void * NOiD_loop (NOiD_node * noid_src);

//==========================

typedef struct NOiD_agenda
{
	void * check;
	void (*func)(void);
	float time;		//intervale
	float wait;		//now + intervale
	float idle;		//before + interval - now;
	struct NOiD_agenda * last;
	struct NOiD_agenda * next;
} NOiD_agenda;

NOiD_agenda * NOiD_schedule (NOiD_agenda * , void (*)(void), float ,void *);
void * NOiD_cancel (NOiD_agenda * noid_rendezvous);
float NOiD_do (NOiD_agenda * , float );
